// D import file generated from 'derelict/assimp3/assimp.d'
module derelict.assimp3.assimp;
public import derelict.assimp3.types;

private 
{
	import derelict.util.loader;
	import derelict.util.system;
	static if (Derelict_OS_Windows)
	{
		static if (size_t.sizeof == 4)
		{
			enum libNames = "assimp.dll, Assimp32.dll";
		}
		else
		{
			static if (size_t.sizeof == 8)
			{
				enum libNames = "assimp.dll, Assimp64.dll";
			}
			else
			{
				static assert(0);
			}
		}
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libassimp.3.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libassimp.so.3, libassimp.so.3.0.0";
			}
			else
			{
				static assert(0, "Need to implement ASSIMP3 libNames for this operating system.");
			}
		}
	}
}
aiReturn aiGetMaterialFloat(const(aiMaterial)* mat, const(char)* key, uint type, uint index, float* _out);
aiReturn aiGetMaterialInteger(const(aiMaterial)* mat, const(char)* key, uint type, uint index, int* _out);
extern (C) nothrow 
{
	alias size_t function() da_aiGetExportFormatCount;
	alias aiExportFormatDesc* function(size_t) da_aiGetExportFormatDescription;
	alias void function(const(aiScene)*, aiScene**) da_aiCopyScene;
	alias aiReturn function(const(aiScene)*, const(char)*, const(char)*, uint) da_aiExportScene;
	alias aiReturn function(const(aiScene)*, const(char)*, const(char)*, aiFileIO*, uint) da_aiExportSceneEx;
	alias const(aiExportDataBlob)* function(const(aiScene)*, const(char)*, uint) da_aiExportSceneToBlob;
	alias void function(const(aiExportDataBlob)*) da_aiReleaseExportBlob;
	alias const(aiScene*) function(const(char)*, uint) da_aiImportFile;
	alias const(aiScene*) function(const(char)*, uint, aiFileIO*) da_aiImportFileEx;
	alias const(aiScene*) function(const(char)*, uint, aiFileIO*, const(aiPropertyStore)*) da_aiImportFileExWithProperties;
	alias const(aiScene*) function(const(void)*, uint, uint, const(char)*) da_aiImportFileFromMemory;
	alias const(aiScene*) function(const(void)*, uint, uint, const(char)*, const(aiPropertyStore)*) da_aiImportFileFromMemoryWithProperties;
	alias const(aiScene*) function(const(aiScene*), uint) da_aiApplyPostProcessing;
	alias aiLogStream function(aiDefaultLogStream, const(char)*) da_aiGetPredefinedLogStream;
	alias void function(const(aiLogStream)*) da_aiAttachLogStream;
	alias void function(aiBool) da_aiEnableVerboseLogging;
	alias aiReturn function(const(aiLogStream)*) da_aiDetachLogStream;
	alias void function() da_aiDetachAllLogStreams;
	alias void function(const(aiScene)*) da_aiReleaseImport;
	alias const(char)* function() da_aiGetErrorString;
	alias aiBool function(const(char)*) da_aiIsExtensionSupported;
	alias void function(aiString*) da_aiGetExtensionList;
	alias void function(const(aiScene)*, aiMemoryInfo*) da_aiGetMemoryRequirements;
	alias aiPropertyStore* function() da_aiCreatePropertyStore;
	alias void function(aiPropertyStore*) da_aiReleasePropertyStore;
	alias void function(aiPropertyStore*, const(char)*, int) da_aiSetImportPropertyInteger;
	alias void function(aiPropertyStore*, const(char)*, float) da_aiSetImportPropertyFloat;
	alias void function(aiPropertyStore*, const(char)*, const(aiString)*) da_aiSetImportPropertyString;
	alias void function(aiQuaternion*, const(aiMatrix3x3)*) da_aiCreateQuaternionFromMatrix;
	alias void function(const(aiMatrix4x4)*, aiVector3D*, aiQuaternion*, aiVector3D*) da_aiDecomposeMatrix;
	alias void function(aiMatrix4x4*) da_aiTransposeMatrix4;
	alias void function(aiMatrix3x3*) da_aiTransposeMatrix3;
	alias void function(aiVector3D*, const(aiMatrix3x3)*) da_aiTransformVecByMatrix3;
	alias void function(aiVector3D*, const(aiMatrix4x4)*) da_aiTransformVecByMatrix4;
	alias void function(aiMatrix4x4*, const(aiMatrix4x4)*) da_aiMultiplyMatrix4;
	alias void function(aiMatrix3x3*, const(aiMatrix3x3)*) da_aiMultiplyMatrix3;
	alias void function(aiMatrix3x3*) da_aiIdentityMatrix3;
	alias void function(aiMatrix4x4*) da_aiIdentityMatrix4;
	alias aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, aiMaterialProperty**) da_aiGetMaterialProperty;
	alias aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, float*, uint*) da_aiGetMaterialFloatArray;
	alias aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, int*, uint*) da_aiGetMaterialIntegerArray;
	alias aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, aiColor4D*) da_aiGetMaterialColor;
	alias aiReturn function(const(aiMaterial)*, const(char)*, uint, uint, aiString*) da_aiGetMaterialString;
	alias uint function(const(aiMaterial)*, aiTextureType) da_aiGetMaterialTextureCount;
	alias aiReturn function(const(aiMaterial)*, aiTextureType, uint, aiString*, aiTextureMapping* m = null, uint* uvindex = null, float* blend = null, aiTextureOp* op = null, aiTextureMapMode* mm = null, uint* flags = null) da_aiGetMaterialTexture;
	alias const(char)* function() da_aiGetLegalString;
	alias uint function() da_aiGetVersionMinor;
	alias uint function() da_aiGetVersionMajor;
	alias uint function() da_aiGetVersionRevision;
	alias uint function() da_aiGetCompileFlags;
}

__gshared 
{
	da_aiGetExportFormatCount aiGetExportFormatCount;
	da_aiGetExportFormatDescription aiGetExportFormatDescription;
	da_aiCopyScene aiCopyScene;
	da_aiExportScene aiExportScene;
	da_aiExportSceneEx aiExportSceneEx;
	da_aiExportSceneToBlob aiExportSceneToBlob;
	da_aiReleaseExportBlob aiReleaseExportBlob;
	da_aiImportFile aiImportFile;
	da_aiImportFileEx aiImportFileEx;
	da_aiImportFileExWithProperties aiImportFileExWithProperties;
	da_aiImportFileFromMemory aiImportFileFromMemory;
	da_aiImportFileFromMemoryWithProperties aiImportFileFromMemoryWithProperties;
	da_aiApplyPostProcessing aiApplyPostProcessing;
	da_aiGetPredefinedLogStream aiGetPredefinedLogStream;
	da_aiAttachLogStream aiAttachLogStream;
	da_aiEnableVerboseLogging aiEnableVerboseLogging;
	da_aiDetachLogStream aiDetachLogStream;
	da_aiDetachAllLogStreams aiDetachAllLogStreams;
	da_aiReleaseImport aiReleaseImport;
	da_aiGetErrorString aiGetErrorString;
	da_aiIsExtensionSupported aiIsExtensionSupported;
	da_aiGetExtensionList aiGetExtensionList;
	da_aiGetMemoryRequirements aiGetMemoryRequirements;
	da_aiCreatePropertyStore aiCreatePropertyStore;
	da_aiReleasePropertyStore aiReleasePropertyStore;
	da_aiSetImportPropertyInteger aiSetImportPropertyInteger;
	da_aiSetImportPropertyFloat aiSetImportPropertyFloat;
	da_aiSetImportPropertyString aiSetImportPropertyString;
	da_aiCreateQuaternionFromMatrix aiCreateQuaternionFromMatrix;
	da_aiDecomposeMatrix aiDecomposeMatrix;
	da_aiTransposeMatrix4 aiTransposeMatrix4;
	da_aiTransposeMatrix3 aiTransposeMatrix3;
	da_aiTransformVecByMatrix3 aiTransformVecByMatrix3;
	da_aiTransformVecByMatrix4 aiTransformVecByMatrix4;
	da_aiMultiplyMatrix4 aiMultiplyMatrix4;
	da_aiMultiplyMatrix3 aiMultiplyMatrix3;
	da_aiIdentityMatrix3 aiIdentityMatrix3;
	da_aiIdentityMatrix4 aiIdentityMatrix4;
	da_aiGetMaterialProperty aiGetMaterialProperty;
	da_aiGetMaterialFloatArray aiGetMaterialFloatArray;
	da_aiGetMaterialIntegerArray aiGetMaterialIntegerArray;
	da_aiGetMaterialColor aiGetMaterialColor;
	da_aiGetMaterialString aiGetMaterialString;
	da_aiGetMaterialTextureCount aiGetMaterialTextureCount;
	da_aiGetMaterialTexture aiGetMaterialTexture;
	da_aiGetLegalString aiGetLegalString;
	da_aiGetVersionMinor aiGetVersionMinor;
	da_aiGetVersionMajor aiGetVersionMajor;
	da_aiGetVersionRevision aiGetVersionRevision;
	da_aiGetCompileFlags aiGetCompileFlags;
}
class DerelictASSIMP3Loader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictASSIMP3Loader DerelictASSIMP3;

shared static this();
